/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * 本文件采用Apache 2.0许可协议进行许可。
 * 未经许可，您不得使用本文件。您可以在以下地址获取许可证：
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * 除非适用法律另有规定或书面协议另有约定，否则根据许可证分发的软件是按"原样"提供的，
 * 不附带任何明示或暗示的担保或条件。有关许可证下的特定语言条款和限制，请参阅许可证。
 */

// 指定包名
package net.micode.notes.data;

// 导入必要的类
import android.content.ContentValues; // 用于数据库内容的存储
import android.content.Context; // 上下文类
import android.database.sqlite.SQLiteDatabase; // SQLite数据库类
import android.database.sqlite.SQLiteOpenHelper; // SQLite数据库帮助类
import android.util.Log; // 日志类

// 导入自定义数据列和常量
import net.micode.notes.data.Notes.DataColumns; // 数据列模型
import net.micode.notes.data.Notes.DataConstants; // 数据常量
import net.micode.notes.data.Notes.NoteColumns; // 笔记列模型

// 创建NotesDatabaseHelper类，继承自SQLiteOpenHelper
public class NotesDatabaseHelper extends SQLiteOpenHelper {
    // 数据库名称
    private static final String DB_NAME = "note.db";

    // 数据库版本号
    private static final int DB_VERSION = 4;

    // 定义表名的接口
    public interface TABLE {
        // 笔记表的名称
        public static final String NOTE = "note";

        // 数据表的名称
        public static final String DATA = "data";
    }

    // 日志标签
    private static final String TAG = "NotesDatabaseHelper";

    // 单例实例
    private static NotesDatabaseHelper mInstance;

    // 创建笔记表的SQL语句
    private static final String CREATE_NOTE_TABLE_SQL =
        "CREATE TABLE " + TABLE.NOTE + "(" +
            NoteColumns.ID + " INTEGER PRIMARY KEY," + // 笔记ID，主键
            NoteColumns.PARENT_ID + " INTEGER NOT NULL DEFAULT 0," + // 父级ID
            NoteColumns.ALERTED_DATE + " INTEGER NOT NULL DEFAULT 0," + // 提醒日期
            NoteColumns.BG_COLOR_ID + " INTEGER NOT NULL DEFAULT 0," + // 背景颜色ID
            NoteColumns.CREATED_DATE + " INTEGER NOT NULL DEFAULT (strftime('%s','now') * 1000)," + // 创建日期
            NoteColumns.HAS_ATTACHMENT + " INTEGER NOT NULL DEFAULT 0," + // 是否有附件
            NoteColumns.MODIFIED_DATE + " INTEGER NOT NULL DEFAULT (strftime('%s','now') * 1000)," + // 修改日期
            NoteColumns.NOTES_COUNT + " INTEGER NOT NULL DEFAULT 0," + // 笔记数量
            NoteColumns.SNIPPET + " TEXT NOT NULL DEFAULT ''," + // 笔记摘要
            NoteColumns.TYPE + " INTEGER NOT NULL DEFAULT 0," + // 笔记类型
            NoteColumns.WIDGET_ID + " INTEGER NOT NULL DEFAULT 0," + // 小部件ID
            NoteColumns.WIDGET_TYPE + " INTEGER NOT NULL DEFAULT -1," + // 小部件类型
            NoteColumns.SYNC_ID + " INTEGER NOT NULL DEFAULT 0," + // 同步ID
            NoteColumns.LOCAL_MODIFIED + " INTEGER NOT NULL DEFAULT 0," + // 本地修改标志
            NoteColumns.ORIGIN_PARENT_ID + " INTEGER NOT NULL DEFAULT 0," + // 原始父级ID
            NoteColumns.GTASK_ID + " TEXT NOT NULL DEFAULT ''," + // GTASK ID
            NoteColumns.VERSION + " INTEGER NOT NULL DEFAULT 0" + // 版本号
        ")";

    // 创建数据表的SQL语句
    private static final String CREATE_DATA_TABLE_SQL =
        "CREATE TABLE " + TABLE.DATA + "(" +
            DataColumns.ID + " INTEGER PRIMARY KEY," + // 数据ID，主键
            DataColumns.MIME_TYPE + " TEXT NOT NULL," + // MIME类型
            DataColumns.NOTE_ID + " INTEGER NOT NULL DEFAULT 0," + // 关联的笔记ID
            NoteColumns.CREATED_DATE + " INTEGER NOT NULL DEFAULT (strftime('%s','now') * 1000)," + // 创建日期
            NoteColumns.MODIFIED_DATE + " INTEGER NOT NULL DEFAULT (strftime('%s','now') * 1000)," + // 修改日期
            DataColumns.CONTENT + " TEXT NOT NULL DEFAULT ''," + // 内容
            DataColumns.DATA1 + " INTEGER," + // 数据字段1
            DataColumns.DATA2 + " INTEGER," + // 数据字段2
            DataColumns.DATA3 + " TEXT NOT NULL DEFAULT ''," + // 数据字段3
            DataColumns.DATA4 + " TEXT NOT NULL DEFAULT ''," + // 数据字段4
            DataColumns.DATA5 + " TEXT NOT NULL DEFAULT ''" + // 数据字段5
        ")";

    // 创建数据表中NOTE_ID字段的索引
    private static final String CREATE_DATA_NOTE_ID_INDEX_SQL =
        "CREATE INDEX IF NOT EXISTS note_id_index ON " +
        TABLE.DATA + "(" + DataColumns.NOTE_ID + ");";

    // 当更新笔记时增加文件夹的笔记计数的触发器
    private static final String NOTE_INCREASE_FOLDER_COUNT_ON_UPDATE_TRIGGER =
        "CREATE TRIGGER increase_folder_count_on_update "+ 
        " AFTER UPDATE OF " + NoteColumns.PARENT_ID + " ON " + TABLE.NOTE +
        " BEGIN " +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.NOTES_COUNT + "=" + NoteColumns.NOTES_COUNT + " + 1" +
        "  WHERE " + NoteColumns.ID + "=new." + NoteColumns.PARENT_ID + ";" +
        " END";

    // 当从文件夹中移动笔记时减少文件夹的笔记计数的触发器
    private static final String NOTE_DECREASE_FOLDER_COUNT_ON_UPDATE_TRIGGER =
        "CREATE TRIGGER decrease_folder_count_on_update " +
        " AFTER UPDATE OF " + NoteColumns.PARENT_ID + " ON " + TABLE.NOTE +
        " BEGIN " +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.NOTES_COUNT + "=" + NoteColumns.NOTES_COUNT + "-1" +
        "  WHERE " + NoteColumns.ID + "=old." + NoteColumns.PARENT_ID +
        "  AND " + NoteColumns.NOTES_COUNT + ">0" + ";" +
        " END";

    // 当在文件夹中插入新笔记时增加文件夹的笔记计数的触发器
    private static final String NOTE_INCREASE_FOLDER_COUNT_ON_INSERT_TRIGGER =
        "CREATE TRIGGER increase_folder_count_on_insert " +
        " AFTER INSERT ON " + TABLE.NOTE +
        " BEGIN " +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.NOTES_COUNT + "=" + NoteColumns.NOTES_COUNT + " + 1" +
        "  WHERE " + NoteColumns.ID + "=new." + NoteColumns.PARENT_ID + ";" +
        " END";

    // 当从文件夹中删除笔记时减少文件夹的笔记计数的触发器
    private static final String NOTE_DECREASE_FOLDER_COUNT_ON_DELETE_TRIGGER =
        "CREATE TRIGGER decrease_folder_count_on_delete " +
        " AFTER DELETE ON " + TABLE.NOTE +
        " BEGIN " +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.NOTES_COUNT + "=" + NoteColumns.NOTES_COUNT + "-1" +
        "  WHERE " + NoteColumns.ID + "=old." + NoteColumns.PARENT_ID +
        "  AND " + NoteColumns.NOTES_COUNT + ">0;" +
        " END";

    // 在插入类型为NOTE的数据时更新笔记内容的触发器
    private static final String DATA_UPDATE_NOTE_CONTENT_ON_INSERT_TRIGGER =
        "CREATE TRIGGER update_note_content_on_insert " +
        " AFTER INSERT ON " + TABLE.DATA +
        " WHEN new." + DataColumns.MIME_TYPE + "='" + DataConstants.NOTE + "'" +
        " BEGIN" +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.SNIPPET + "=new." + DataColumns.CONTENT +
        "  WHERE " + NoteColumns.ID + "=new." + DataColumns.NOTE_ID + ";" +
        " END";

    // 当类型为NOTE的数据发生变化时更新笔记内容的触发器
    private static final String DATA_UPDATE_NOTE_CONTENT_ON_UPDATE_TRIGGER =
        "CREATE TRIGGER update_note_content_on_update " +
        " AFTER UPDATE ON " + TABLE.DATA +
        " WHEN old." + DataColumns.MIME_TYPE + "='" + DataConstants.NOTE + "'" +
        " BEGIN" +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.SNIPPET + "=new." + DataColumns.CONTENT +
        "  WHERE " + NoteColumns.ID + "=new." + DataColumns.NOTE_ID + ";" +
        " END";

    // 当类型为NOTE的数据被删除时更新笔记内容的触发器
    private static final String DATA_UPDATE_NOTE_CONTENT_ON_DELETE_TRIGGER =
        "CREATE TRIGGER update_note_content_on_delete " +
        " AFTER delete ON " + TABLE.DATA +
        " WHEN old." + DataColumns.MIME_TYPE + "='" + DataConstants.NOTE + "'" +
        " BEGIN" +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.SNIPPET + "=''" +
        "  WHERE " + NoteColumns.ID + "=old." + DataColumns.NOTE_ID + ";" +
        " END";

    // 删除已删除笔记的所有数据的触发器
    private static final String NOTE_DELETE_DATA_ON_DELETE_TRIGGER =
        "CREATE TRIGGER delete_data_on_delete " +
        " AFTER DELETE ON " + TABLE.NOTE +
        " BEGIN" +
        "  DELETE FROM " + TABLE.DATA +
        "   WHERE " + DataColumns.NOTE_ID + "=old." + NoteColumns.ID + ";" +
        " END";

    // 删除已删除文件夹中的笔记的触发器
    private static final String FOLDER_DELETE_NOTES_ON_DELETE_TRIGGER =
        "CREATE TRIGGER folder_delete_notes_on_delete " +
        " AFTER DELETE ON " + TABLE.NOTE +
        " BEGIN" +
        "  DELETE FROM " + TABLE.NOTE +
        "   WHERE " + NoteColumns.PARENT_ID + "=old." + NoteColumns.ID + ";" +
        " END";

    // 当文件夹被移动到垃圾桶时移动文件夹中的笔记的触发器
    private static final String FOLDER_MOVE_NOTES_ON_TRASH_TRIGGER =
        "CREATE TRIGGER folder_move_notes_on_trash " +
        " AFTER UPDATE ON " + TABLE.NOTE +
        " WHEN new." + NoteColumns.PARENT_ID + "=" + Notes.ID_TRASH_FOLER +
        " BEGIN" +
        "  UPDATE " + TABLE.NOTE +
        "   SET " + NoteColumns.PARENT_ID + "=" + Notes.ID_TRASH_FOLER +
        "  WHERE " + NoteColumns.PARENT_ID + "=old." + NoteColumns.ID + ";" +
        " END";

    // 构造函数，接受上下文参数
    public NotesDatabaseHelper(Context context) {
        super(context, DB_NAME, null, DB_VERSION); // 调用父类构造函数
    }

    // 创建笔记表
    public void createNoteTable(SQLiteDatabase db) {
        db.execSQL(CREATE_NOTE_TABLE_SQL); // 执行创建表的SQL语句
        reCreateNoteTableTriggers(db); // 重新创建触发器
        createSystemFolder(db); // 创建系统文件夹
        Log.d(TAG, "note table has been created"); // 日志输出
    }

    // 重新创建笔记表的所有触发器
    private void reCreateNoteTableTriggers(SQLiteDatabase db) {
        db.execSQL("DROP TRIGGER IF EXISTS increase_folder_count_on_update"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS decrease_folder_count_on_update"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS decrease_folder_count_on_delete"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS delete_data_on_delete"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS increase_folder_count_on_insert"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS folder_delete_notes_on_delete"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS folder_move_notes_on_trash"); // 删除触发器

        // 创建新的触发器
        db.execSQL(NOTE_INCREASE_FOLDER_COUNT_ON_UPDATE_TRIGGER);
        db.execSQL(NOTE_DECREASE_FOLDER_COUNT_ON_UPDATE_TRIGGER);
        db.execSQL(NOTE_DECREASE_FOLDER_COUNT_ON_DELETE_TRIGGER);
        db.execSQL(NOTE_DELETE_DATA_ON_DELETE_TRIGGER);
        db.execSQL(NOTE_INCREASE_FOLDER_COUNT_ON_INSERT_TRIGGER);
        db.execSQL(FOLDER_DELETE_NOTES_ON_DELETE_TRIGGER);
        db.execSQL(FOLDER_MOVE_NOTES_ON_TRASH_TRIGGER);
    }

    // 创建系统文件夹
    private void createSystemFolder(SQLiteDatabase db) {
        ContentValues values = new ContentValues(); // 创建内容值对象

        // 为通话记录文件夹插入记录
        values.put(NoteColumns.ID, Notes.ID_CALL_RECORD_FOLDER);
        values.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
        db.insert(TABLE.NOTE, null, values); // 插入记录

        // 创建根文件夹
        values.clear(); // 清空内容值
        values.put(NoteColumns.ID, Notes.ID_ROOT_FOLDER);
        values.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
        db.insert(TABLE.NOTE, null, values); // 插入记录

        // 创建临时文件夹
        values.clear(); // 清空内容值
        values.put(NoteColumns.ID, Notes.ID_TEMPARAY_FOLDER);
        values.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
        db.insert(TABLE.NOTE, null, values); // 插入记录

        // 创建垃圾桶文件夹
        values.clear(); // 清空内容值
        values.put(NoteColumns.ID, Notes.ID_TRASH_FOLER);
        values.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
        db.insert(TABLE.NOTE, null, values); // 插入记录
    }

    // 创建数据表
    public void createDataTable(SQLiteDatabase db) {
        db.execSQL(CREATE_DATA_TABLE_SQL); // 执行创建表的SQL语句
        reCreateDataTableTriggers(db); // 重新创建触发器
        db.execSQL(CREATE_DATA_NOTE_ID_INDEX_SQL); // 创建索引
        Log.d(TAG, "data table has been created"); // 日志输出
    }

    // 重新创建数据表的所有触发器
    private void reCreateDataTableTriggers(SQLiteDatabase db) {
        db.execSQL("DROP TRIGGER IF EXISTS update_note_content_on_insert"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS update_note_content_on_update"); // 删除触发器
        db.execSQL("DROP TRIGGER IF EXISTS update_note_content_on_delete"); // 删除触发器

        // 创建新的触发器
        db.execSQL(DATA_UPDATE_NOTE_CONTENT_ON_INSERT_TRIGGER);
        db.execSQL(DATA_UPDATE_NOTE_CONTENT_ON_UPDATE_TRIGGER);
        db.execSQL(DATA_UPDATE_NOTE_CONTENT_ON_DELETE_TRIGGER);
    }

    // 获取NotesDatabaseHelper的单例实例
    static synchronized NotesDatabaseHelper getInstance(Context context) {
        if (mInstance == null) { // 如果实例为空，则创建新的实例
            mInstance = new NotesDatabaseHelper(context);
        }
        return mInstance; // 返回实例
    }

    // 当创建数据库时被调用
    @Override
    public void onCreate(SQLiteDatabase db) {
        createNoteTable(db); // 创建笔记表
        createDataTable(db); // 创建数据表
    }

    // 当升级数据库时被调用
    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        boolean reCreateTriggers = false; // 重创建触发器的标志
        boolean skipV2 = false; // 跳过V2的标志

        if (oldVersion == 1) { // 如果旧版本是1
            upgradeToV2(db); // 升级到V2
            skipV2 = true; // 跳过V2的标志设为true
            oldVersion++; // 增加版本号
        }

        if (oldVersion == 2 && !skipV2) { // 如果旧版本是2且没有跳过
            upgradeToV3(db); // 升级到V3
            reCreateTriggers = true; // 设置重创建触发器的标志为true
            oldVersion++; // 增加版本号
        }

        if (oldVersion == 3) { // 如果旧版本是3
            upgradeToV4(db); // 升级到V4
            oldVersion++; // 增加版本号
        }

        if (reCreateTriggers) { // 如果需要重创建触发器
            reCreateNoteTableTriggers(db); // 重新创建笔记表的触发器
            reCreateDataTableTriggers(db); // 重新创建数据表的触发器
        }

        if (oldVersion != newVersion) { // 如果版本不一致，则抛出异常
            throw new IllegalStateException("Upgrade notes database to version " + newVersion
                    + " fails");
        }
    }

    // 升级到V2
    private void upgradeToV2(SQLiteDatabase db) {
        db.execSQL("DROP TABLE IF EXISTS " + TABLE.NOTE); // 删除笔记表
        db.execSQL("DROP TABLE IF EXISTS " + TABLE.DATA); // 删除数据表
        createNoteTable(db); // 创建笔记表
        createDataTable(db); // 创建数据表
    }

    // 升级到V3
    private void upgradeToV3(SQLiteDatabase db) {
        // 删除未使用的触发器
        db.execSQL("DROP TRIGGER IF EXISTS update_note_modified_date_on_insert");
        db.execSQL("DROP TRIGGER IF EXISTS update_note_modified_date_on_delete");
        db.execSQL("DROP TRIGGER IF EXISTS update_note_modified_date_on_update");
        // 为笔记添加一个新的字符ID列
        db.execSQL("ALTER TABLE " + TABLE.NOTE + " ADD COLUMN " + NoteColumns.GTASK_ID
                + " TEXT NOT NULL DEFAULT ''");
        // 添加一个垃圾桶系统文件夹
        ContentValues values = new ContentValues();
        values.put(NoteColumns.ID, Notes.ID_TRASH_FOLER);
        values.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
        db.insert(TABLE.NOTE, null, values); // 插入记录
    }

    // 升级到V4
    private void upgradeToV4(SQLiteDatabase db) {
        db.execSQL("ALTER TABLE " + TABLE.NOTE + " ADD COLUMN " + NoteColumns.VERSION
                + " INTEGER NOT NULL DEFAULT 0"); // 为笔记表添加版本列
    }
}
